﻿Class Tablet : Implements Api.Invoker
    'UI系へ。Palette上のボタンなどと同等にする。
    Dim _commands As List(Of Api.Command)
    Dim _brush As Api.Brush
    Dim _canvas As Api.Canvas
    Dim _stroke As Api.Stroke

    Property Brush() As Api.Brush Implements Api.Invoker.Brush
        Get
            Brush = Me._brush
        End Get
        Set(ByVal value As Api.Brush)
            Me._brush = value
        End Set
    End Property

    Property Canvas() As Api.Canvas Implements Api.Invoker.Canvas
        Get
            Canvas = Me._canvas
        End Get
        Set(ByVal value As Api.Canvas)
            Me._canvas = value
        End Set
    End Property

    Property Stroke() As Api.Stroke Implements Api.Invoker.Stroke
        Get
            Stroke = Me._stroke
        End Get
        Set(ByVal value As Api.Stroke)
            Me._stroke = value
        End Set
    End Property

    Sub Invoke() Implements Api.Invoker.Invoke
        Dim command As IEnumerator(Of Api.Command) = Me._commands.GetEnumerator()
        Do While command.MoveNext()
            command.Current.Invoke(Me)
        Loop
        'Log.add(Command)
    End Sub

    Sub AddCommand(ByVal command As Api.Command)
        Me._commands.Add(command)
    End Sub

    ' コンストラクター
    Shared _tablets = New Dictionary(Of String, Tablet)
    Shared ReadOnly Property Instance(Optional ByVal name As String = "") As Tablet
        Get
            If Tablet._tablets.ContainsKey(name) Then
                Instance = Tablet._tablets(name)
            Else
                Instance = New Tablet(name)
            End If
        End Get
    End Property

    Private Sub New(Optional ByVal name As String = "")
        Me._commands = New List(Of Api.Command)
        Me.AddCommand(New Plugin.Commands.NullBrushCommand)
        WindowsApplication1.Tablet._tablets(name) = Me
    End Sub

End Class
