﻿Public MustInherit Class Brush : Implements Api.Brush
    Dim _image As System.Drawing.Image = New System.Drawing.Bitmap(5, 5)
    Dim _separation As Single = (Me._image.Size.Width + Me._image.Size.Height) * 5

    Public Overridable Property Separation() As Single Implements Api.Brush.Separation
        Get
            Separation = _separation
        End Get
        Set(ByVal value As Single)
            _separation = value
        End Set
    End Property

    Public Overridable Property Image() As System.Drawing.Image Implements Api.Brush.Image
        Get
            Image = Me._image
        End Get
        Set(ByVal value As System.Drawing.Image)
            Me._image = value
        End Set
    End Property


    Public Overridable Sub Draw(ByVal c As Api.Canvas, ByVal s As Api.Stroke)
        Dim sp = s.GetRevisedStrokePoints()
        If sp.Count > 0 Then
            Dim _p As Api.StrokePoint = sp(0)
            c.Draw(Me.Image, _p.Location)
            For Each p In sp.GetRange(1, sp.Count - 1)
                If Math.Sqrt((p.Location.X - _p.Location.X) ^ 2 + (p.Location.Y - _p.Location.Y) ^ 2) >= Me._separation Then
                    c.Draw(Me.Image, p.Location)
                    _p = p
                End If
            Next
        End If
    End Sub

    Public Sub New()
        Dim g = System.Drawing.Graphics.FromImage(Me._image)
        g.FillRectangle(Drawing.Brushes.Red, Me._image.GetBounds(System.Drawing.GraphicsUnit.Pixel))
        g.Dispose()
    End Sub
End Class
