﻿Public MustInherit Class Stroke : Implements Api.Stroke
    Dim _strokePoints As List(Of Api.StrokePoint)

    Public Property StrokePoints() As List(Of Api.StrokePoint) Implements Api.Stroke.StrokePoints
        Get
            StrokePoints = Me._strokePoints
        End Get
        Set(ByVal value As System.Collections.Generic.List(Of Api.StrokePoint))
            Me._strokePoints = value
        End Set
    End Property

    Public Function GetRevisedStrokePoints() As List(Of Api.StrokePoint) Implements Api.Stroke.GetRevisedStrokePoints
        GetRevisedStrokePoints = Me.Revise(Me._strokePoints)
    End Function

    Protected Overridable Function Revise(ByVal strokePoints As List(Of Api.StrokePoint)) As List(Of Api.StrokePoint)
        Revise = New List(Of Api.StrokePoint)
        If strokePoints.Count > 0 Then
            Revise.Add(strokePoints(0))
            Dim p_ = strokePoints(0)
            Dim _bw As Integer
            For Each p In strokePoints.GetRange(1, strokePoints.Count - 1)
                Dim ps As System.Drawing.Point = p_.Location
                Dim pe As System.Drawing.Point = p.Location
                Dim yx As Boolean = Math.Abs(pe.X - ps.X) < Math.Abs(pe.Y - ps.Y)
                If yx Then
                    Swap(ps.X, ps.Y)
                    Swap(pe.X, pe.Y)
                End If
                Dim a, k
                a = IIf((pe.X - ps.X) <> 0, (pe.Y - ps.Y) / (pe.X - ps.X), 1)
                k = ps.Y - a * ps.X
                Dim bw_ = p.Presure
                Dim sign As Integer = IIf(ps.X <= pe.X, 1, -1)
                Dim numLoops As Integer = Math.Max(Math.Ceiling(Math.Abs(pe.X - ps.X) / 1), 1)
                Dim count As Integer = 0
                For x = ps.X To pe.X Step 1 * sign
                    Dim y = a * x + k

                    If yx Then Swap(x, y)

                    Revise.Add(New StrokePoint(New System.Drawing.Point(x, y), _bw + (bw_ - _bw) / numLoops * count))

                    If yx Then Swap(x, y)

                    count = count + 1
                Next
                _bw = bw_
                p_ = p
            Next
        End If
    End Function

    Protected Sub Swap(ByRef a, ByRef b)
        Dim c
        c = a
        a = b
        b = c
    End Sub

    Public Sub New(Optional ByVal strokePoints As List(Of Api.StrokePoint) = Nothing)
        If strokePoints Is Nothing Then
            strokePoints = New List(Of Api.StrokePoint)
        End If
        Me._strokePoints = strokePoints
    End Sub

End Class
